﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Dotway.WPF.Samples.DotwaySampleApplication
{
    /// <summary>
    /// Interaction logic for DynamicWrapPanelSample.xaml
    /// </summary>
    public partial class DynamicWrapPanelSample : UserControl
    {
        public DynamicWrapPanelSample()
        {
            InitializeComponent();
        }

        private Random random = new Random();

        private void AddButtonClick(object sender, RoutedEventArgs e)
        {
            Border border = new Border();
            border.HorizontalAlignment = HorizontalAlignment.Stretch;
            border.VerticalAlignment = VerticalAlignment.Stretch;
            border.Background = new SolidColorBrush(Color.FromRgb((byte)random.Next(255), (byte)random.Next(255), (byte)random.Next(255)));
            border.BorderThickness = new Thickness(1);
            border.BorderBrush = Brushes.Black;

            TextBlock tb = new TextBlock();
            tb.Text = "This is an item.";
            tb.TextWrapping = TextWrapping.Wrap;
            border.Child = tb;

            dynamicPanel.Children.Add(border);
        }

        private void RemoveButtonClick(object sender, RoutedEventArgs e)
        {
            if (dynamicPanel.Children.Count > 0)
            {
                dynamicPanel.Children.RemoveAt(0);
            }
        }
    }
}
