﻿//--------------------------------------------------------------------------------------
// 
// WPF ShaderEffect HLSL -- GrayscaleEffect
//
//--------------------------------------------------------------------------------------

//-----------------------------------------------------------------------------------------
// Shader constant register mappings (scalars - float, double, Point, Color, Point3D, etc.)
//-----------------------------------------------------------------------------------------

float blocksX : register(c0);
float blocksY : register(c1);

//--------------------------------------------------------------------------------------
// Sampler Inputs (Brushes, including ImplicitInput)
//--------------------------------------------------------------------------------------

sampler2D implicitInputSampler : register(S0);


//--------------------------------------------------------------------------------------
// Pixel Shader
//--------------------------------------------------------------------------------------

float4 main(float2 uv : TEXCOORD) : COLOR
{			
	float2 blocks = float2(blocksX, blocksY);
	float2 blockSize = 1.0 / blocks;	
	float2 newuv = floor(uv / blockSize)* blockSize;	
			
	float4 color = tex2D(implicitInputSampler, newuv);    	    
    
    return color;
}

