﻿//--------------------------------------------------------------------------------------
// 
// WPF ShaderEffect HLSL -- WaveEffect
//
//--------------------------------------------------------------------------------------

//-----------------------------------------------------------------------------------------
// Shader constant register mappings (scalars - float, double, Point, Color, Point3D, etc.)
//-----------------------------------------------------------------------------------------

float frequency : register(c0);
float amplitude : register(c1);

//--------------------------------------------------------------------------------------
// Sampler Inputs (Brushes, including ImplicitInput)
//--------------------------------------------------------------------------------------

sampler2D implicitInputSampler : register(S0);


//--------------------------------------------------------------------------------------
// Pixel Shader
//--------------------------------------------------------------------------------------

float4 main(float2 uv : TEXCOORD) : COLOR
{
	uv.y = uv.y + (sin(uv.x * frequency) * amplitude);	
    float4 color = tex2D(implicitInputSampler, uv);
    
    return color;
}

